/* 
Sakul http://wwww.sakul.cz SakulRaider@seznam.cz
2014 Program Odectu z elektromeru
Verze programu 1.1
Optimalizován kód pro práci s RAM, aby bylo dostatek paměti pro Ethernetový modul a tím se zvíšila stabilita.

// Dořešit: 

*/

#include <EEPROM.h>
#include <LiquidCrystal.h>
#include <EtherCard.h>

// Inicializace displeje a nastaveni (RS-4, E-5, D4-9, D5-6, D6-17, D7-7)
 LiquidCrystal lcd(4, 5, 9, 6, 17, 7);

// ---------------------------------------------------------------------------------------------------------
 
// Nezapomeň zadat unikátní MAC adresu pro Ethernetový modul !!!
static byte mymac[] = { 0x00,0x0c,0x43,0x34,0xdb,0x2c };             // (MAC až db:32)
byte Ethernet::buffer[700];                                          // Buffer pro ethernetový modul (původní hodnota 700, ale už se nevešel program)
char website[] PROGMEM = "www.arduino.sakul.cz";                     // Adresa kam se data odesílají (www.el.comtex.cz)

// ---------------------------------------------------------------------------------------------------------

int analogPin = 0;                         // Analogový vstup pro měření napětí
int ADrd;                                  // Hodnota analogového vstupu
int ADrdMin = 500;                         // Minimální přípustná hodnota napětí na vstupu (při nižší je vyvoláno uložení všech dat do EEPROM)
int ADrdMax = 1000;                        // Maximální přípustná hodnota napětí na vstupu
int elektromerH = 0;                       // Hodnota elektromeru Vyšší (Hodnota elektromeru se skládá ze dvou čísel)
int elektromerL = 0;                       // Hodnota elektromeru Nižší
int pulzy;                                 // Aktuální hodnota pulzů z elektroměru
int delicka;                               // Přednastavená hodnota pro dělení pulzů z elektroměru
int chyby = 0;                             // Počet chyb při odesílání na web
int chybyBUF;                              // Buffer pro počítání chyb
char KWh[10];                              // Proměná pro hodnotu elektroměru v KWh
char mekovka[16];                          // Info o MAC adrese
unsigned long timer1;                      // Pomocná pro zasílání hodnot do databáze na webu spolu s proměnou (interval)
unsigned long time;                        // Pomocná pro měření času 1 sekunda (obnovování údajů na displeji)
unsigned long time1;                       // Pomocná pro měření času 24 hodin (ciklus automatického ukládání do EEPROM)
unsigned long  interval = 30000;         // Interval zasílání hodnot do databáze na webu (1 za hodinu = 3 600 000) (20000=20sekund)
boolean Podpeti = false;                   // Příznak že již byly data při podpětí jednou uložena
boolean NazElektComplete = false;          // Příznak dokončeného čtení z UART

String NazElekt = "Elektomer-001";         // Název elektromeru NUTNO ZADAT JESTE DALE V PROGRAMU !!!
String firmware = " firmware 1.1";         // Verze Firmware
String web = "www.sakul.cz";               // Info o mé webové stránce

// Registry pro práci s EEPROM
byte byte1H=0;                             // Pomocné registry pro zápis a čtení EEPROM
byte byte2H=0;
byte byte1L=0;
byte byte2L=0;
byte byte1pulzy=0;
byte byte2pulzy=0;
int adresa=0;                              // Počáteční adresa pro zápis nebo čtení do EEPROM

// Definice Vstupů
const int Tlac = 3;                        // Tlacitko
const int Jumper1 = 18;                    // Jumper pro dělící poměr 2000 pulzů na KWh (pokud není žádný osazen je to 800/KWh)
const int Jumper2 = 19;                    // Jumper pro dělící poměr 10 pulzů na KWh
const int InEther = 16;                    // Hlášení o stavu Ether. modulu (LED červená)
const int LED3 = 15;                       // Výstup na LED3 žlutá (ERROR Ethernet)
int TlacState = 0;                         // Pomocný registr o stavu vstupu Tlac
int Jumper1State = 0;                      // Pomocný registr o stavu vstupu Jumper1
int Jumper2State = 0;                      // Pomocný registr o stavu vstupu Jumper2
int InEtherState = 0;                      // Pomocný registr o stavu vstupu InEther




void setup () {
  chybyBUF = 0;                             // Vymazání bufferu chyb
  chyby = 0;                                // Vymazání pomocného registru detekce chyby 
  NazElekt.reserve(16);                     // Rezervování místa pro název elektromeru (16 Bytů)
  Serial.begin(38400);                      // Konfigurace UARTU
  pinMode(LED3, OUTPUT);                    // Konfigurace pinu jako výstup
  pinMode(InEther, OUTPUT);                 // Konfigurace pinu jako výstup
  digitalWrite(LED3,LOW);                   // Zhasne LED3
  pinMode(Tlac, INPUT_PULLUP);              // Nastaveni pinu na digitalni vystupy a PULL-UP odpor
  pinMode(Jumper1, INPUT_PULLUP);           // Nastaveni pinu na digitalni vystupy a PULL-UP odpor
  pinMode(Jumper2, INPUT_PULLUP);           // Nastaveni pinu na digitalni vystupy a PULL-UP odpor
  attachInterrupt(0,preruseni, FALLING);    // Nastavi preruseni při přechodu z LOG-1 na LOG-0 na pinu INT0 (Pin 4)
//  attachInterrupt(1,ResetEther, FALLING);    // Nastavi preruseni při přechodu z LOG-0 na LOG-1 na pinu INT1 (Pin 5) RISING
 
  lcd.begin(16, 2);                            // Konfigurace LCD a inicializace
  lcd.clear();  
  // Vymazání všech uložených hodnot
  TlacState = digitalRead(Tlac);               // Kontrola dlouhého stisku tlačítka 5s
  if (TlacState == false){
    lcd.clear();                              
    lcd.setCursor (0,0);                       // Informace na displej, že budou všechny uložené hodnoty vymazány
    lcd.print(F("Podrz tlacitko:"));
    lcd.setCursor (0,1);
    lcd.print (F("MAZU hodnoty !!!"));
    delay(5000);
  }
  TlacState = digitalRead(Tlac);
  if (TlacState == false){
     EEPROM.write(adresa, byte1H);              // Vymazání všech dat z EEPROM
     EEPROM.write(adresa + 1, byte2H);
     EEPROM.write(adresa + 2, byte1L);
     EEPROM.write(adresa + 3, byte2L);
     EEPROM.write(adresa + 4, byte1pulzy);
     EEPROM.write(adresa + 5, byte2pulzy);
     adresa = 0;
     lcd.clear();                              
     lcd.setCursor (0,0);                       // Informace na displej, že byly všechny uložené hodnoty vymazány
     lcd.print(F("Hodnoty smazany"));
     lcd.setCursor (0,1);
     lcd.print (F("Uvolni tlacitko"));
     delay (5000);
     }
     
  lcd.clear();                              
  lcd.setCursor (2,0);                          // Napis co se zobrazuje než je přidělena IP adresa
  lcd.print(F("Cekam na DHCP"));
  lcd.setCursor (3,2);
  lcd.print (F("CEKEJTE..."));
     
  // Načtení všech hodnot z EEPROM 
  byte1H = EEPROM.read(adresa);                
  byte2H = EEPROM.read(adresa + 1);
  byte1L = EEPROM.read(adresa + 2);
  byte2L = EEPROM.read(adresa + 3);
  byte1pulzy = EEPROM.read(adresa + 4);
  byte2pulzy = EEPROM.read(adresa + 5);
  adresa = 0;                                           // Vynulování adresy pro čtení nebo zápis do EEPROM  
  elektromerH = byte1H + (byte2H << 8);                 // Převod načtených hodnot z EEPROM do proměných
  elektromerL = byte1L + (byte2L << 8);
  pulzy = byte1pulzy + (byte2pulzy << 8);
  
  // Zjištění a nastavení dělícího poměru
  Jumper1State = digitalRead(Jumper1);
  Jumper2State = digitalRead(Jumper2);
   if (Jumper1State == false){delicka = 2000;}         // Nastaveni děličky na 2000/KWh
   else if (Jumper2State == false){delicka = 1000;}      // Nastaveni děličky na 1000/KWh (V současnosti testovací hodnota)
     else {delicka = 800;}                             // Pokud není žádný Jumper, tak 800/KWh

// ----------------------------------------------------------------------------------------------------------------------- 

 // Konfigurace Ethernetu
  Serial.println(F("\n[webClient]"));

  if (ether.begin(sizeof Ethernet::buffer, mymac) == 0){
     delay (5);
  Serial.println(F( "Failed to access Ethernet controller"));
  lcd.clear();                                         // ERROR Ethernet controller
  lcd.setCursor (0,0);                   
  lcd.print(F("CHYBA na Modulu:"));
  lcd.setCursor (2,2);
  lcd.print (F("Ethernetu !!"));
  delay (5000);
   }
  if (!ether.dhcpSetup()){
     digitalWrite(InEther,HIGH);                       // Signál do procesoru Watchdogu, že má resetovat procesor Ethernetu (Červená LED)
     Serial.println(F("DHCP failed"));
     lcd.clear();                                      // ERROR DHCP
     lcd.setCursor (2,0);                   
     lcd.print(F("ERROR DHCP !!"));
     lcd.setCursor (4,2);
     lcd.print (F("Zadna IP"));
     delay (5000);
   }

  ether.printIp("IP:  ", ether.myip);
  ether.printIp("GW:  ", ether.gwip);  
  ether.printIp("DNS: ", ether.dnsip);
  sprintf(mekovka, "%02X%02X%02X%02X%02X%02X", mymac[0],mymac[1],mymac[2],mymac[3],mymac[4],mymac[5]); // Vyseparování MAC adresy, převod na HEX a uložení do proměnné mekovka
  Serial.print (F("MAC: "));
  Serial.println (mekovka);

  if (!ether.dnsLookup(website))
    delay (5);
    Serial.println(F("DNS failed"));
    
  ether.printIp("SRV: ", ether.hisip);
// ----------------------------------------------------------------------------------------------------------------------- 
}

//::::::::::::::::::::::: Konec SETUPU ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

void loop () {
 
   if (chyby >= 2){                                 // Pokud 2x po sobě neprojdou data na web je vyhlášena chyba
       lcd.clear();                                 // Informace, že data nebyla na web odeslána ERROR
       lcd.setCursor (1,0);                   
       lcd.print(F("Data Odeslana:"));
       lcd.setCursor (2,1);
       lcd.print (F("NEUSPESNE!!!"));
       digitalWrite(LED3,HIGH);                     // Žlutá LED3 hlásí chybu zápisu do Databáze
       delay(6000);
       chyby = 0;      
   }
   
   if (chybyBUF >= 3){                              // Buffer chyb pro odesílání dat na web. V případě přetečení reset ETHER. modulu
      setup();
     
   }

 // ---------------------------------------------------------------------------------------------------------------------- 
   ether.packetLoop(ether.packetReceive());
 
   char queryString[128] = {0};
    sprintf(queryString, "&kwh=%05d%04d", elektromerH, elektromerL);      // Zformátování hodnoty elektromeru ze dvou proměných
    
   if (millis() > timer1) {                                               // Cekaci smicka viz promena interval
     timer1 = millis() + interval;
     Serial.println();
     Serial.print(F("<<< ZACATEK PRENOSU "));
     ether.browseUrl(PSTR("/add_data.php?elektromer=Elektromer-001"), queryString, website, my_callback); // Odeslání dat na web
     lcd.clear(); 
     lcd.setCursor (0,0);                                                 // Info na dispej, že jsou odesílána data na web
     lcd.print(F("Odesilam data..."));
     lcd.setCursor (3,1);
     lcd.print (F("CEKEJTE..."));
     delay(3000);
     chyby ++;
     chybyBUF ++;     
  }
 // ---------------------------------------------------------------------------------------------------------------------- 
 
 ADrd = analogRead (analogPin);              // Precti napeti z AD prevodniku (dostaneme hodnotu  0 - 1023)

 if (micros() - time >= 1000000) {            // Obnovování údajů na displeji každou vteřinu
  lcd.clear();                                // Vymazání celého displeje
  lcd.setCursor (0,0);                        // Vypisuje data na displej
  lcd.print(F("U="));
  if (ADrd <= ADrdMin){lcd.print (F("Min"));}             // Pokud je napětí menší jak ADrdMin, je zobrazen nápis Min místo hodnoty
    else if (ADrd >= ADrdMax){lcd.print (F("Max"));}      // Pokud je napětí větší jak ADrdMax, je zobrazen nápis Max místo hodnoty
       else {lcd.print (ADrd);};                       // Pokud je hodnota v toleranci je zobranena přímo
  lcd.print(F("P="));
  lcd.print (pulzy);
  lcd.print(F("/"));
  lcd.print (delicka);
  sprintf(KWh, "%05d%04d", elektromerH, elektromerL);    // Zformátování hodnoty elektroměru
  lcd.setCursor (0,2);
  lcd.print(F("KWh = "));
  lcd.print (KWh);
  time = micros();  
  }

  if (ADrd <= ADrdMin){                      // Kontrola napětí
     if (Podpeti == false){                  // Kontrola zda již nebyla data jednou uložena
     byte1H = elektromerH;                   // Rozdeleni cisla z int na 2 bajty pred zapisem do eeprom
     byte2H = elektromerH >> 8;
     byte1L = elektromerL;                   // Rozdeleni cisla z int na 2 bajty pred zapisem do eeprom
     byte2L = elektromerL >> 8;
     byte1pulzy = pulzy;                     // Rozdeleni cisla z int na 2 bajty pred zapisem do eeprom
     byte2pulzy = pulzy >> 8;   
     EEPROM.write(adresa, byte1H);
     EEPROM.write(adresa + 1, byte2H);
     EEPROM.write(adresa + 2, byte1L);
     EEPROM.write(adresa + 3, byte2L);
     EEPROM.write(adresa + 4, byte1pulzy);
     EEPROM.write(adresa + 5, byte2pulzy);
     adresa = 0;
     Podpeti = true;                         // Nastaveni příznaku že byl již zápis proveden
    }
  }      
  
  TlacState = digitalRead(Tlac);             // Hlídání stisku tlačítka
  if (TlacState == false){
     info();
     }
    
 // Ukládání dat do EEPROM každý den
 if (millis() - time1 >= 86400000) {          // Uložit stav elektroměru každých 24hodin (86400000)
    ulozData();
    setup();                                  // Restart ether. modulu každý den 
    }  
  
}

//::::::::::::::::::::::::::: Konec Hlavního programu :::::::::::::::::::::::::::::::::::::::::::::::::::::::::

void preruseni(){                            // Podprogram pro počítání pulzů z elektroměru
     pulzy ++;
     
   if (pulzy >= delicka){                    // Převod pulzů z elektroměru na KWh
     elektromerL ++;                         // Přičtení každé celé KWh do paměni (složena ze 2 registrů)
     pulzy = 0;
     }
     if (elektromerL >= 10000){              // Přičtení do horního registru KWh a vymazání nižšího registru KWh
      elektromerH ++;
      elektromerL = 0;
      }   
        if (elektromerL >= 32760){           // Teoretické maximum 32767. Při přetečení se počítá znova
        elektromerH = 0;
        }
 }

void info(){                                 // Po stisku tlačítka vypíše info o názvu elektroměru na LCD po dobu 5 sekund
  lcd.begin(16, 2);                          // Konfigurace LCD a inicializace
  lcd.clear(); 
  lcd.setCursor (2,0);                   
  lcd.print(web);
  lcd.setCursor (1,2);
  lcd.print (firmware);
  delay(5000);                               // Doba zobrazení (5 sekund)
  lcd.clear();                               // Smazání displeje
  lcd.setCursor (0,0);                   
  lcd.print(F("Naz. elektromeru"));             // Zobrazení názvu elektromeru
  lcd.setCursor (1,2);
  lcd.print (NazElekt);
  delay(5000);
  lcd.clear();                               // Smazání displeje
  lcd.setCursor (0,0);                   
  lcd.print(ether.myip[0]);                  // Zobrazení IP adresy
  lcd.print('.');
  lcd.print(ether.myip[1]);
  lcd.print('.');
  lcd.print(ether.myip[2]);
  lcd.print('.');
  lcd.print(ether.myip[3]); 
  lcd.setCursor (0,1);
  lcd.print(F("MAC:"));
  lcd.setCursor (4,1);
  lcd.print (mekovka);                         // Zobrazení MAC adresy
  delay(9000);
}

void ulozData(){                             // Ukládání dat do EEPROM každý den
  lcd.begin(16, 2);                          // Konfigurace LCD a inicializace
  lcd.clear(); 
  lcd.setCursor (0,0);                   
  lcd.print(F("UKLADAM DATA !!!"));
  lcd.setCursor (3,2);
  lcd.print (F("CEKEJTE..."));
  delay(3000);
     byte1H = elektromerH;                   // Rozdeleni cisla z int na 2 bajty pred zapisem do eeprom
     byte2H = elektromerH >> 8;
     byte1L = elektromerL;                   // Rozdeleni cisla z int na 2 bajty pred zapisem do eeprom
     byte2L = elektromerL >> 8;
     byte1pulzy = pulzy;                     // Rozdeleni cisla z int na 2 bajty pred zapisem do eeprom
     byte2pulzy = pulzy >> 8;   
     EEPROM.write(adresa, byte1H);
     EEPROM.write(adresa + 1, byte2H);
     EEPROM.write(adresa + 2, byte1L);
     EEPROM.write(adresa + 3, byte2L);
     EEPROM.write(adresa + 4, byte1pulzy);
     EEPROM.write(adresa + 5, byte2pulzy);
     adresa = 0;                              // Opětovné nastavení adresy na 0
  lcd.clear(); 
  lcd.setCursor (2,0);                   
  lcd.print(F("DATA ULOZENA"));
  lcd.setCursor (0,2);
  lcd.print (F(" "));
  delay(3000);     
  Podpeti = false;                            // Smazání příznaku, že byly data při podpětí jednou uložena
  time1 = millis(); 
}

// called when the client request is complete
static void my_callback (byte status, word off, word len) {
  Serial.println(F(">>>"));
  Ethernet::buffer[off+300] = 0;
  Serial.println((const char*) Ethernet::buffer + off);
  Serial.println(F("<<< KONEC >>>"));
  lcd.clear();                                 // Informace, že data byla na web odeslána úspěšně
  lcd.setCursor (1,0);                   
  lcd.print(F("Data Odeslana:"));
  lcd.setCursor (4,1);
  lcd.print (F("USPESNE"));
  digitalWrite(LED3,LOW);                     // Zhasne LED3 (žlutá), že není spojení s webem nebo že není IP adresa
  digitalWrite(InEther,LOW);                  // Vypne signál do procesoru Watchdogu, že má resetovat procesor Ethernetu
  delay(3000);
  chyby = 0;
  chybyBUF = 0;
}
